VERSION 5.00
Begin VB.Form frmMain 
   AutoRedraw      =   -1  'True
   Caption         =   "Change BorderStyle At RunTime"
   ClientHeight    =   2940
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4965
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   OLEDropMode     =   1  'Manuell
   ScaleHeight     =   2940
   ScaleWidth      =   4965
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton cmdChange 
      Caption         =   "Make My Border Fixed"
      Default         =   -1  'True
      Height          =   495
      Left            =   1065
      TabIndex        =   0
      Top             =   1223
      Width           =   2835
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
' Manipulate the style bits of a VB Form
' via the SetWindowLong and GetWindowLong API functions.
'
Option Explicit

Private Const GWL_STYLE As Long = (-16&)
Private Const GWL_EXSTYLE As Long = (-20&)
Private Const WS_THICKFRAME As Long = &H40000
Private Const WS_MINIMIZEBOX As Long = &H20000
Private Const WS_MAXIMIZEBOX As Long = &H10000

Private Const WS_EX_TOOLWINDOW As Long = &H80&

Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd&, ByVal nIndex&) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd&, ByVal nIndex&, ByVal dwNewLong&) As Long

' SetWindowPos Flags
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOZORDER = &H4
Private Const SWP_NOREDRAW = &H8
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_FRAMECHANGED = &H20       ' The frame changed: send WM_NCCALCSIZE
Private Const SWP_SHOWWINDOW = &H40
Private Const SWP_HIDEWINDOW = &H80
Private Const SWP_NOCOPYBITS = &H100
Private Const SWP_NOOWNERZORDER = &H200     ' Don't do owner Z ordering

Private Const SWP_DRAWFRAME = SWP_FRAMECHANGED
Private Const SWP_NOREPOSITION = SWP_NOOWNERZORDER

' SetWindowPos() hwndInsertAfter values
Private Const HWND_TOP = 0
Private Const HWND_BOTTOM = 1
Private Const HWND_TOPMOST = -1
Private Const HWND_NOTOPMOST = -2

Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd&, ByVal hWndInsertAfter&, ByVal x&, ByVal y&, ByVal cx&, ByVal cy&, ByVal wFlags&) As Long

'
' Toggle the BorderStyle depending on the caption of the Button.
'
Private Sub cmdChange_Click()
    Dim bToggleStyle As Boolean, bToggleExStyle As Boolean
    
    ' Change the button caption to the appropriate string
    ' and set the toggle variables.
    With cmdChange
        Select Case .Caption
            Case "Make My Border Fixed"
                .Caption = "Turn Me Into A Tool Window"
                
                bToggleStyle = True
                
            Case "Turn Me Into A Tool Window"
                .Caption = "Change Me Back, Please!"
                
                bToggleExStyle = True
                
            Case Else
                .Caption = "Make My Border Fixed"
                
                bToggleExStyle = True
                bToggleStyle = True
                
        End Select
    End With
    '
    ' Durch Kombination der einzelnen Einstellungen fr die Buttons und den Rahmen
    ' lassen sich auch flache Fenster erzeugen (ohne 3D-Rahmen) etc.
    '
    If bToggleStyle Then
        ' This call sets the regular style bits. In this case, we toggle between
        ' fixed and sizeable borders.
        Call SetWindowLong(hWnd, GWL_STYLE, GetWindowLong(hWnd, GWL_STYLE) Xor _
            (WS_THICKFRAME Or WS_MINIMIZEBOX Or WS_MAXIMIZEBOX))
    End If
    
    If bToggleExStyle Then
        ' This call sets the extended style bits. In this case we toggle between
        ' tool window and regular window style.
        Call SetWindowLong(hWnd, GWL_EXSTYLE, GetWindowLong(hWnd, GWL_EXSTYLE) Xor WS_EX_TOOLWINDOW)
    End If
    
    ' Tell the nonclient area of the Form to redraw itself.
    Call SetWindowPos(hWnd, 0&, 0&, 0&, 0&, 0&, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOZORDER Or SWP_FRAMECHANGED)
End Sub
